
 !********************************************************************************                             
 !*****************************MAIN PROGRAM***************************************
 !*                                                                              *
 !*Programma per la risoluzione dell'equazione della diffusione monodimensionale*
 !*                                                                              *
 !********************************************************************************
 
                   
 PROGRAM  diffusion
 
 IMPLICIT NONE
 
 
 integer                              :: i,k,j,y      ! indice di calcolo
 integer                              :: outape=11    ! file di output
 
 integer, parameter                   :: nx=40        ! numero di celle
 integer, parameter                   :: nstep=100    ! numero di step nel tempo
 integer, parameter                   :: lun=50       ! lunghezza del dominio in mm
 
 double precision                     :: dx,dt        ! passo delle griglie
 double precision, parameter          :: Diff= 1.0    ! coefficiente di diffusione
 double precision, parameter          :: stec= 0.0957 ! fraz. molare stechiometrica 
                                                      ! di Ch4 per una mole di mix aria+ch4     
 double precision , dimension(1:nx)   :: uk           ! vettore concentrazione
 double precision , dimension(1:nx)   :: ukp1         ! vettore di calcolo
 
 
 !--------------------------------------------------------------------------------
 !
 !                              CORPO DEL PROGRAMMA
 !
 !--------------------------------------------------------------------------------
 
 open (outape,file='concCh4.dat')
 dx = lun/nx
 print*,dx
 dt=0.5*dx*dx
 print*,dt
 !-------inizializzazione-----------
 do  i=2,nx-1
       uk(i)=0.0
 end do
 uk(1)=stec
 uk(nx)=0
 !---------time step loop-----------
 do k=1,nstep
 !---------grid computation--------- 
       do i=2,nx-1
            ukp1(i)=uk(i)+(dt/(dx*dx))*Diff*(uk(i+1)-2*uk(i)+uk(i-1))
       end do
 !------------nodo n------------------------
 !----condizione alla Neumann---------------
 !------------du/dx=0-----------------------
       ukp1(nx)=uk(nx)+(dt/(dx*dx))*Diff*(-2*uk(nx)+2*uk(nx-1))
       do j=2,nx
            uk(j)=ukp1(j)
       end do
       print *,'passo numero',k
  end do
  !Scrittura dei dati nel file concCh4.dat------
  do y=1,nx
       write(outape,1) uk(y)
       1 format( e13.5)
  end do     
  print *, 'Normal termination'
  
 end PROGRAM        
